# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities

__all__ = ['BotmanContentProtectionJavascriptInjectionRuleArgs', 'BotmanContentProtectionJavascriptInjectionRule']

@pulumi.input_type
class BotmanContentProtectionJavascriptInjectionRuleArgs:
    def __init__(__self__, *,
                 config_id: pulumi.Input[builtins.int],
                 content_protection_javascript_injection_rule: pulumi.Input[builtins.str],
                 security_policy_id: pulumi.Input[builtins.str]):
        """
        The set of arguments for constructing a BotmanContentProtectionJavascriptInjectionRule resource.
        :param pulumi.Input[builtins.int] config_id: Unique identifier of the security configuration
        :param pulumi.Input[builtins.str] content_protection_javascript_injection_rule: The content protection JavaScript injection rule
        :param pulumi.Input[builtins.str] security_policy_id: Unique identifier of the security policy
        """
        pulumi.set(__self__, "config_id", config_id)
        pulumi.set(__self__, "content_protection_javascript_injection_rule", content_protection_javascript_injection_rule)
        pulumi.set(__self__, "security_policy_id", security_policy_id)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> pulumi.Input[builtins.int]:
        """
        Unique identifier of the security configuration
        """
        return pulumi.get(self, "config_id")

    @config_id.setter
    def config_id(self, value: pulumi.Input[builtins.int]):
        pulumi.set(self, "config_id", value)

    @property
    @pulumi.getter(name="contentProtectionJavascriptInjectionRule")
    def content_protection_javascript_injection_rule(self) -> pulumi.Input[builtins.str]:
        """
        The content protection JavaScript injection rule
        """
        return pulumi.get(self, "content_protection_javascript_injection_rule")

    @content_protection_javascript_injection_rule.setter
    def content_protection_javascript_injection_rule(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "content_protection_javascript_injection_rule", value)

    @property
    @pulumi.getter(name="securityPolicyId")
    def security_policy_id(self) -> pulumi.Input[builtins.str]:
        """
        Unique identifier of the security policy
        """
        return pulumi.get(self, "security_policy_id")

    @security_policy_id.setter
    def security_policy_id(self, value: pulumi.Input[builtins.str]):
        pulumi.set(self, "security_policy_id", value)


@pulumi.input_type
class _BotmanContentProtectionJavascriptInjectionRuleState:
    def __init__(__self__, *,
                 config_id: Optional[pulumi.Input[builtins.int]] = None,
                 content_protection_javascript_injection_rule: Optional[pulumi.Input[builtins.str]] = None,
                 content_protection_javascript_injection_rule_id: Optional[pulumi.Input[builtins.str]] = None,
                 security_policy_id: Optional[pulumi.Input[builtins.str]] = None):
        """
        Input properties used for looking up and filtering BotmanContentProtectionJavascriptInjectionRule resources.
        :param pulumi.Input[builtins.int] config_id: Unique identifier of the security configuration
        :param pulumi.Input[builtins.str] content_protection_javascript_injection_rule: The content protection JavaScript injection rule
        :param pulumi.Input[builtins.str] content_protection_javascript_injection_rule_id: Unique identifier of a content protection JavaScript injection rule
        :param pulumi.Input[builtins.str] security_policy_id: Unique identifier of the security policy
        """
        if config_id is not None:
            pulumi.set(__self__, "config_id", config_id)
        if content_protection_javascript_injection_rule is not None:
            pulumi.set(__self__, "content_protection_javascript_injection_rule", content_protection_javascript_injection_rule)
        if content_protection_javascript_injection_rule_id is not None:
            pulumi.set(__self__, "content_protection_javascript_injection_rule_id", content_protection_javascript_injection_rule_id)
        if security_policy_id is not None:
            pulumi.set(__self__, "security_policy_id", security_policy_id)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> Optional[pulumi.Input[builtins.int]]:
        """
        Unique identifier of the security configuration
        """
        return pulumi.get(self, "config_id")

    @config_id.setter
    def config_id(self, value: Optional[pulumi.Input[builtins.int]]):
        pulumi.set(self, "config_id", value)

    @property
    @pulumi.getter(name="contentProtectionJavascriptInjectionRule")
    def content_protection_javascript_injection_rule(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        The content protection JavaScript injection rule
        """
        return pulumi.get(self, "content_protection_javascript_injection_rule")

    @content_protection_javascript_injection_rule.setter
    def content_protection_javascript_injection_rule(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "content_protection_javascript_injection_rule", value)

    @property
    @pulumi.getter(name="contentProtectionJavascriptInjectionRuleId")
    def content_protection_javascript_injection_rule_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Unique identifier of a content protection JavaScript injection rule
        """
        return pulumi.get(self, "content_protection_javascript_injection_rule_id")

    @content_protection_javascript_injection_rule_id.setter
    def content_protection_javascript_injection_rule_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "content_protection_javascript_injection_rule_id", value)

    @property
    @pulumi.getter(name="securityPolicyId")
    def security_policy_id(self) -> Optional[pulumi.Input[builtins.str]]:
        """
        Unique identifier of the security policy
        """
        return pulumi.get(self, "security_policy_id")

    @security_policy_id.setter
    def security_policy_id(self, value: Optional[pulumi.Input[builtins.str]]):
        pulumi.set(self, "security_policy_id", value)


class BotmanContentProtectionJavascriptInjectionRule(pulumi.CustomResource):

    pulumi_type = "akamai:index/botmanContentProtectionJavascriptInjectionRule:BotmanContentProtectionJavascriptInjectionRule"

    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 config_id: Optional[pulumi.Input[builtins.int]] = None,
                 content_protection_javascript_injection_rule: Optional[pulumi.Input[builtins.str]] = None,
                 security_policy_id: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        """
        Create a BotmanContentProtectionJavascriptInjectionRule resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.int] config_id: Unique identifier of the security configuration
        :param pulumi.Input[builtins.str] content_protection_javascript_injection_rule: The content protection JavaScript injection rule
        :param pulumi.Input[builtins.str] security_policy_id: Unique identifier of the security policy
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: BotmanContentProtectionJavascriptInjectionRuleArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a BotmanContentProtectionJavascriptInjectionRule resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param BotmanContentProtectionJavascriptInjectionRuleArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(BotmanContentProtectionJavascriptInjectionRuleArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 config_id: Optional[pulumi.Input[builtins.int]] = None,
                 content_protection_javascript_injection_rule: Optional[pulumi.Input[builtins.str]] = None,
                 security_policy_id: Optional[pulumi.Input[builtins.str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = BotmanContentProtectionJavascriptInjectionRuleArgs.__new__(BotmanContentProtectionJavascriptInjectionRuleArgs)

            if config_id is None and not opts.urn:
                raise TypeError("Missing required property 'config_id'")
            __props__.__dict__["config_id"] = config_id
            if content_protection_javascript_injection_rule is None and not opts.urn:
                raise TypeError("Missing required property 'content_protection_javascript_injection_rule'")
            __props__.__dict__["content_protection_javascript_injection_rule"] = content_protection_javascript_injection_rule
            if security_policy_id is None and not opts.urn:
                raise TypeError("Missing required property 'security_policy_id'")
            __props__.__dict__["security_policy_id"] = security_policy_id
            __props__.__dict__["content_protection_javascript_injection_rule_id"] = None
        super(BotmanContentProtectionJavascriptInjectionRule, __self__).__init__(
            'akamai:index/botmanContentProtectionJavascriptInjectionRule:BotmanContentProtectionJavascriptInjectionRule',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            config_id: Optional[pulumi.Input[builtins.int]] = None,
            content_protection_javascript_injection_rule: Optional[pulumi.Input[builtins.str]] = None,
            content_protection_javascript_injection_rule_id: Optional[pulumi.Input[builtins.str]] = None,
            security_policy_id: Optional[pulumi.Input[builtins.str]] = None) -> 'BotmanContentProtectionJavascriptInjectionRule':
        """
        Get an existing BotmanContentProtectionJavascriptInjectionRule resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[builtins.int] config_id: Unique identifier of the security configuration
        :param pulumi.Input[builtins.str] content_protection_javascript_injection_rule: The content protection JavaScript injection rule
        :param pulumi.Input[builtins.str] content_protection_javascript_injection_rule_id: Unique identifier of a content protection JavaScript injection rule
        :param pulumi.Input[builtins.str] security_policy_id: Unique identifier of the security policy
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _BotmanContentProtectionJavascriptInjectionRuleState.__new__(_BotmanContentProtectionJavascriptInjectionRuleState)

        __props__.__dict__["config_id"] = config_id
        __props__.__dict__["content_protection_javascript_injection_rule"] = content_protection_javascript_injection_rule
        __props__.__dict__["content_protection_javascript_injection_rule_id"] = content_protection_javascript_injection_rule_id
        __props__.__dict__["security_policy_id"] = security_policy_id
        return BotmanContentProtectionJavascriptInjectionRule(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> pulumi.Output[builtins.int]:
        """
        Unique identifier of the security configuration
        """
        return pulumi.get(self, "config_id")

    @property
    @pulumi.getter(name="contentProtectionJavascriptInjectionRule")
    def content_protection_javascript_injection_rule(self) -> pulumi.Output[builtins.str]:
        """
        The content protection JavaScript injection rule
        """
        return pulumi.get(self, "content_protection_javascript_injection_rule")

    @property
    @pulumi.getter(name="contentProtectionJavascriptInjectionRuleId")
    def content_protection_javascript_injection_rule_id(self) -> pulumi.Output[builtins.str]:
        """
        Unique identifier of a content protection JavaScript injection rule
        """
        return pulumi.get(self, "content_protection_javascript_injection_rule_id")

    @property
    @pulumi.getter(name="securityPolicyId")
    def security_policy_id(self) -> pulumi.Output[builtins.str]:
        """
        Unique identifier of the security policy
        """
        return pulumi.get(self, "security_policy_id")

